#version 430 core

uniform vec2 nearFarPlane;
uniform vec3 lightPosition;

in vec4 fragPositionWorld;

layout(location=0) out vec2 color;

void main(void)
{
	float dist = distance(fragPositionWorld, vec4(lightPosition, 1.0f));
	float distNormalized = dist / nearFarPlane.y;
	
	float moment1 = distNormalized;
	float moment2 = distNormalized * distNormalized;

	float dx = dFdx(moment1);
	float dy = dFdy(moment1);
	moment2 += 0.25 * (dx * dx + dy * dy);

	color = vec2(moment1, moment2);
}
